#define DOCTEST_CONFIG_NO_MULTITHREADING
#define DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN
#include "doctest.h"
#include "histogram_internal.h"
#include "svg_internal.h"
#include <string>

TEST_CASE("distinct positive numbers") {
    double min = 0;
    double max = 0;
    bool empty_vector = false;
    find_minmax({1, 2}, min, max, empty_vector);
    CHECK(empty_vector == false);
    CHECK(min == 1);
    CHECK(max == 2);
}

TEST_CASE("single number") {
    double min = 0;
    double max = 0;
    bool empty_vector = false;
    find_minmax({1}, min, max, empty_vector);
    CHECK(empty_vector == false);
    CHECK(min == 1);
    CHECK(max == 1);
}

TEST_CASE("negative numbers") {
    double min = 0;
    double max = 0;
    bool empty_vector = false;
    find_minmax({-1, -2}, min, max, empty_vector);
    CHECK(empty_vector == false);
    CHECK(min == -2);
    CHECK(max == -1);
}

TEST_CASE("identical numbers") {
    double min = 0;
    double max = 0;
    bool empty_vector = false;
    find_minmax({2, 2}, min, max, empty_vector);
    CHECK(empty_vector == false);
    CHECK(min == 2);
    CHECK(max == 2);
}

TEST_CASE("empty vector") {
    double min = 0;
    double max = 0;
    bool empty_vector = false;
    find_minmax({}, min, max, empty_vector);
    CHECK(empty_vector == true);
    CHECK(min == 0);
    CHECK(max == 0);
}

TEST_CASE("correct color") {
    bool check = check_color("red");
    CHECK(check == true);
    check = check_color("#FF FFF");
    CHECK(check == true);
}

TEST_CASE("incorrect color") {
    bool check = check_color("re d");
    CHECK(check == false);
    check = check_color("red green blue");
    CHECK(check == false);
}
